/*
Copyright (C) 2019 RRe36

All Rights Reserved unless otherwise explicitly stated.


By downloading this you have agreed to the license and terms of use.
These can be found inside the included license-file or here: https://github.com/rre36/glsl_kappa/blob/master/LICENSE

Violating these terms may be penalized with actions according to the Digital Millennium Copyright Act (DMCA), the Information Society Directive and/or similar laws depending on your country.
*/

#define color_preset 0  //[0 1 2]

/* ------ atmosphere settings ------ */

    /* ------ cloud settings ------ */
    #define vcloud_enabled
    #define vcloud_light
    #define vcloud_samples 14 //[6 8 10 12 14 16 18 20]
    //#define vcloud_adaptive_samples
    #define vcloud_alt 160.0    //[80.0 100.0 120.0 140.0 160.0 180.0 200.0]
    #define vcloud_depth 14.0   //[8.0 10.0 12.0 14.0 16.0 18.0 20.0]
    #define vcloud_clip 1200.0   //[400.0 600.0 800.0 1000.0 1200.0 1400.0 1600.0 1800.0 2000.0]
    #define vcloud_edge 4       //[1 2 4 6 8 10 12 14 16 18 20 24 28 32]
    //#define vcloud_storyMode
    #define vcloud_fast_ms

    #define vcloud2_enabled
    #define vcloud2_samples 10 //[6 8 10 12 14 16 18 20]
    #define vcloud2_alt 300.0    //[160.0 180.0 200.0 220. 240.0 260.0 280.0 300.0 320.0 340.0 360.0 380.0 400.0]
    #define vcloud2_depth 12.0   //[8.0 10.0 12.0 14.0 16.0 18.0 20.0]
    #define vcloud2_clip 1600.0   //[1000.0 1200.0 1400.0 1600.0 1800.0 2000.0 2500.0 3000.0 4000.0 5000.0 6000.0]

    /* ------ fog settings ------ */
    #define vfog_enabled
    #define vfog_quality 1.0    //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]
    #define vfog_density 1.0    //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 10.0 12.0 14.0]
    //#define vfog_clouds

    #ifdef vfog_enabled
        #define vfog_translucents
    #endif

    #define vfog_bilateral

    #define vwater_enabled
    #define vwater_quality 1.0  //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]
    #define vwater_bilateral
    #define vwater_density 1.0    //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 10.0 12.0 14.0]



/* ------ lighting settings ------ */
//#define shadowfilter_hq
#define ambientOcclusion_enabled

#define minlight_luma 0.1   //[0.1 0.2 0.3 0.4 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 9.0 10.0]



/* ------ world settings ------ */
//#define labpbr_enabled
//#define normalmap_enabled
#define normalmap_format 0      //[0 1]0-lab 1.2, 1-lab1.1

    /* ------ reflections settings ------ */
    #define reflections_enabled

    #ifdef reflections_enabled
        #define ssr_enabled

        #ifdef vcloud_enabled
            #define cloud_reflections_enabled
        #endif
    #endif

    #ifdef reflections_enabled
        #define custom_water_normal
    #endif

    #define rough_reflections_enabled

    /* ------ water settings ------ */
    #ifdef reflections_enabled
        #define custom_water_normal
    #endif

    #define custom_water_color

    #define water_normal_octaves 3  //[2 3 4 5 6 7 8]

#define wind_effects_enabled
#define wind_intensity 1.0  //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]



/* ------ post processing settings ------ */
#define taa_enabled
//#define upscale_sharpen
#define vignette_enabled

    /* ------ exposure settings ------ */
    //#define manual_exposure_enabled
    #define manual_exposure 5.0     //[0.1 0.3 0.5 1.0 1.5 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0 10.0 12.0 14.0 16.0 18.0 20.0 25.0 30.0 40.0 50.0]
    #define exposure_minlum 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.2 1.4 1.6 1.8 2.0 2.2. 2.4 2.6 2.8 3.0 3.5 4.0 5.0 6.0 8.0 10.0 15.0 20.0]
    #define exposure_speed 1.0      //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 4.0]

    /* ----- camera settings ------ */    
    #define bloom_enabled
    #define bloom_intensity 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

    #define motionblur_enabled
    #define motionblur_samples 8    //[4 6 8 10 12 14 16]
    #define motionblur_size 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

    /* ------ color grading settings ------ */
    //#define do_colorgrading

    #define vibrance_int 1.0    //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define saturation_int 1.0  //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define gamma_curve 1.0     //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define brightness_int 0.0  //[-0.5 -0.4 -0.3 -0.2 -0.1 0.0 0.1 0.2 0.3 0.4 0.5]
    #define constrast_int 1.0   //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

    #define colorlum_r 1.0      //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define colorlum_g 1.0      //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define colorlum_b 1.0      //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]



/* ------ internals ------ */
#define SKY_RENDER_LOD 2
#define SKYREF_LOD 3.0
#define cloud_atmos_density 2.8e-3
#define DEBUG_VIEW 0    //[0 1 2 3 4] 0-off, 1-whiteworld, 2-ao